#include <inttypes.h>
#include <stdio.h>

#include "fmcadc100m14b4cha.h"

uint32_t adc_devid;

static void adc100m14b4cha_lib_bsc_test1(struct m_test *m_test)
{
	int err;

	err = adc_init();
	m_assert_int_eq(0, err);

	adc_exit();
}


static void adc100m14b4cha_lib_bsc_test2_setup(struct m_test *m_test)
{
	int err;

	err = adc_init();
	m_assert_int_eq(0, err);
}
static void adc100m14b4cha_lib_bsc_test2_teardown(struct m_test *m_test)
{
	adc_exit();
}
static void adc100m14b4cha_lib_bsc_test2(struct m_test *m_test)
{
	struct adc_dev *adc;
	int err;

	adc = adc_open(ADC100M14B4CHA_TYPE_NAME, adc_devid, 0, 0, ADC_F_FLUSH);
	m_assert_mem_not_null(adc);
	err = adc_close(adc);
	m_assert_int_eq(0, err);
}



int main(int argc, char *argv[])
{
	struct m_test adc100m14b4cha_lib_bsc_tests[] = {
		m_test(NULL, adc100m14b4cha_lib_bsc_test1, NULL),
		m_test(adc100m14b4cha_lib_bsc_test2_setup,
		       adc100m14b4cha_lib_bsc_test2,
		       adc100m14b4cha_lib_bsc_test2_teardown),
	};
	struct m_suite adc100m14b4cha_lib_bsc_suite = {
		.name = "FMC ADC 100M 4Bit 4Channel - Basic",
		.desc = "It checks that the library can be initalized and devices opend/closed",
		.flags = M_ERRNO_CHECK | M_ERRNO_FUNC,
		.private = NULL,
		.tests = adc100m14b4cha_lib_bsc_tests,
		.test_count = M_ARRAY_SIZE(adc100m14b4cha_lib_bsc_tests),
		.set_up = NULL,
		.tear_down = NULL,
		.strerror = NULL,
	};
	int i;

	if (argc !=2)
		goto err_devid;

	i = sscanf(argv[1], "0x%"SCNx32, &adc_devid);
	if (i != 1)
		goto err_devid;


	m_suite_run(&adc100m14b4cha_lib_bsc_suite);
	m_suite_run(&adc100m14b4cha_lib_cfg_suite);
	m_suite_run(&adc100m14b4cha_lib_trg_suite);

	return 0;

err_devid:
	fprintf(stderr, "You must provide a device ID in hexadecimal format 0x0000\n");
	exit(1);
}
